FROM alpine:3.7
MAINTAINER Disassembler <disassembler@dasm.cz>

RUN \
 # Install Python2 runtime
 apk --no-cache add python2

RUN \
 # Add edge/testing repository
 echo '@edge http://dl-cdn.alpinelinux.org/alpine/edge/testing' >>/etc/apk/repositories \
 # Install runtime dependencies
 && apk --no-cache add geos@edge libpq nginx s6 zlib

RUN \
 # Install build dependencies
 apk --no-cache add --virtual .deps build-base git postgresql-dev python2-dev py2-pip zlib-dev \
 # Install CTS
 && git clone --depth 1 https://github.com/theirc/CTS /srv/cts \
 # Force psycopg2 version update for compatibility with PostgreSQL 10
 && sed -i 's/psycopg2==2.5.2/psycopg2==2.7.1/' /srv/cts/requirements/base.txt \
 && pip install -r /srv/cts/requirements/production.txt \
 # Hackfix geos version detection
 && sed -i 's/\$//' /usr/lib/python2.7/site-packages/django/contrib/gis/geos/libgeos.py \
 # Make manage.py globally executable
 && chmod +x /srv/cts/manage.py \
 && ln -s /srv/cts/manage.py /usr/local/bin/manage.py \
 # Compile static files
 && sed -i '/debug_toolbar/d' /srv/cts/cts/settings/dev.py \
 && DJANGO_SETTINGS_MODULE=cts.settings.dev manage.py collectstatic -l --noinput \
 # Create OS user
 && addgroup -S -g 8006 cts \
 && adduser -S -u 8006 -h /srv/cts -s /bin/false -g cts -G cts cts \
 && chown -R cts:cts /srv/cts \
 # Cleanup
 && apk --no-cache del .deps \
 && find /srv/cts -name '.git*' -exec rm -rf {} + \
 && rm -rf /root/.cache

COPY docker/ /

VOLUME ["/srv/cts/cts/settings"]
EXPOSE 8080

ENV DJANGO_SETTINGS_MODULE cts.settings.spotter
WORKDIR /srv/cts
CMD ["s6-svscan", "/etc/services.d"]
